#ifndef DUMPFILE_H
#define DUMPFILE_H

/* $Id: dumpfile.h,v 1.5 2006/12/06 17:42:10 akira Exp $ */

struct _DumpDevice;

typedef struct _DumpFile {
	struct _DumpDevice	*device;
	const char		*name;
	int			 fd;
	const char		*dir;
	off_t			 data_offset;
	off_t			 page_desc_offset;
} DumpFile;

DumpFile	*open_dump_file(char *dir);
int		 rename_dump_file(DumpFile *);
int		 read_page_desc(DumpFile *, page_desc_t *);
int		 write_page_desc(DumpFile *, page_desc_t *);
int		 read_page_data(DumpFile *, void *data, page_desc_t *);
int		 write_page_data(DumpFile *, const void *data, page_desc_t *);
int		 dump_read(DumpFile *, void *data, uint32_t size);
int		 dump_write(DumpFile *, const void *data, uint32_t size);
void		*alloc_blocks(DumpFile *, int block_nr);
int		 read_blocks(DumpFile *, void *data, int block_nr);
int		 write_blocks(DumpFile *, const void *data, int block_nr);
void		 set_data_offset(DumpFile *);
void		 calc_data_offset(DumpFile *);

static inline int dump_seek(DumpFile *dump_file, off_t off) {
	if (lseek(dump_file->fd, off, SEEK_SET) != off)
		return -1;

	return 0;
}

#endif
